

#ifndef _BOARD_H
#define _BOARD_H

/* default values for memory setup */
//											   L   N   B  Turbo-mode  System-bus LCD-freq
#define _CCCR					0x08000290	// 16  2.5 1  520MHz      208MHz     104MHz
#define _MSC0					0x91D080B0
#define _MSC1					0x7FF87FF8
#define _MSC2					0xA144FFF8	/* nCS5(VLIO) */
#define _SA1110					0x00000000
#define _MDCNFG					0x1A391AC3	/* bank 0 */
#define _MDREFR					0x0101801E 	/* bank 0 */
#define _MECR					0x00000003
#define _SXCNFG					0x00000000
#define _MCMEM0					0x00010504
#define _MCMEM1					0x00010504
#define _MCATT0					0x00010504
#define _MCATT1					0x00010504
#define _MCIO0					0x00004715
#define _MCIO1					0x00004715
#define _FLYCNFG				0x00000000
#define _MDMRS					0x00000000

/* flash map */
#define LOADER_SRAM_BASE		0x00000000
#define LOADER_DRAM_BASE		0xA1E00000
#define LOADER_MAX_SIZE			0x00040000
#define KERNEL_SRAM_BASE		0x00040000
#define KERNEL_DRAM_BASE		0xA0008000
#define KERNEL_MAX_SIZE			0x001C0000
#ifdef USE_RAMDISK
# define RAMDISK_SRAM_BASE		0x001C0000
# define RAMDISK_DRAM_BASE		0xA1000000
# define RAMDISK_MAX_SIZE		0x00300000
# define ROOTFS_SRAM_BASE		0x004C0000
# define ROOTFS_DRAM_BASE		0xA0000000
# define ROOTFS_MAX_SIZE		0x01B40000
#else
# define RAMDISK_SRAM_BASE		0x00200000
# define RAMDISK_DRAM_BASE		0xA1000000
# define RAMDISK_MAX_SIZE		0x00300000
# define ROOTFS_SRAM_BASE		0x00200000
# define ROOTFS_DRAM_BASE		0xA0000000
# define ROOTFS_MAX_SIZE		0x01E00000
#endif

#define _GPDR0					0xC020B800
#define _GPDR1					0xFC028082	//(GP49:nPWE)
#define _GPDR2					0x02C1FFFF
//#define _GPDR3				0x00020000
#define _GPDR3					0x00220000	// I2C
#define _GPSR0					0x00003000
#define _GPSR1					0x00000000
#define _GPSR2					0x00010000
#define _GPSR3					0x00020000
#define _GPCR0					0x00000800
#define _GPCR1					0x00000000
#define _GPCR2					0x00000000
#define _GPCR3					0x00000000
#define _GAFR0L					0x80000000
#define _GAFR0U					0xA5000410	//(GP18:RDY)
#define _GAFR1L					0x60008018
#define _GAFR1U					0xAAA00008	//(GP49:nPWE)
#define _GAFR2L					0xAAAAAAAA
#define _GAFR2U					0x0004A002
#define _GAFR3L					0x00000000
//#define _GAFR3U				0x00000008
#define _GAFR3U					0x00001408	// I2C

#define BOOTADDR				0xA3F00000	/* 64MB - 1MB */
#define BOOT_PARAMS				0xA0000100

#endif
