

#ifndef _NETWORK_H
#define _NETWORK_H

#include <netheader.h>
#include <byteorder.h>

#define PORT_BOOTP				68
#define PORT_TFTP				69
#define PORT_TFTP_CLIENT		7777

extern bool net_send_packet(void *packet, int len);
extern bool net_recv_poll(void);
extern void netif_rx(void *pkt, int len);
extern void net_set_haddr(const void *haddr);

extern int set_ether_header(void *packet, const void *dmac, uint16 prot);
extern int set_ip_header(void *packet, uint32 sip, uint32 dip, int prot, int len);
extern int set_udp_header(void *packet, uint16 dport, uint16 sport, int len);

extern void *find_mac_addr(uint32 ip);

extern void ping(uint32 ip, void (*handler)(uint32 dip, uint16 seq));
extern uint32 inet_addr(const char *ip);
extern char *inet_ntoa(uint32 ip);

extern uchar *mac_ntoa(const void *mac);
extern void *mac_aton(const uchar *str);


#endif
