

#ifndef _STATUS_H
#define _STATUS_H

struct setup_t {
	uint32 sid;
	uint32 size;
	uint32 myipaddr;
	uint32 destipaddr;
	uchar  myhaddr[8];
	uchar  autoboot[0x100];
};

struct map {
	const char *name;
	ulong sramb;		/* static memeory base */
	ulong srams;		/* static memeory size */
	ulong dramb;		/* dynamic memeory base */
	ulong drams;		/* dynamic memeory size */
	ulong maxs;			/* max size */
};


extern struct setup_t *setup;
extern void save_setup(void);

extern struct map *find_map(const char *name);


#if __GNUC__ >= 3 && __GNUC_MINOR__ >= 3
# define __attribute_used__		__attribute__((__used__))
#else
# define __attribute_used__		__attribute__((__unused__))
#endif
#define __bsetup	__attribute_used__ __attribute__((section(".setup")))

#endif
