#include <time.h>
#include <ieb.h>

#define 	FPGA_LED_CS		0x12400000
#define 	FPGA_CLCD_CMD		0x12300000
#define 	FPGA_CLCD_DATA		0x12380000
#define 	FPGA_FND_CS0    	0x11000000
#define 	FPGA_FND_CS1    	0x11100000
#define 	FPGA_FND_CS2    	0x11200000
#define 	FPGA_FND_CS3    	0x11300000
#define 	FPGA_FND_CS4    	0x11400000
#define 	FPGA_FND_CS5    	0x11500000
#define 	FPGA_FND_CS6    	0x11600000
#define	 	FPGA_FND_CS7    	0x11700000
#define 	FPGA_DOT_COL_1          0x11800000
#define 	FPGA_DOT_COL_2          0x11900000
#define 	FPGA_DOT_COL_3          0x11A00000
#define 	FPGA_DOT_COL_4          0x11B00000
#define 	FPGA_DOT_COL_5          0x11C00000


#define 	LED_CS			(*((volatile unsigned char *)(FPGA_LED_CS)))
#define 	CLCD_CMD_ADDR		(*((volatile unsigned char *)(FPGA_CLCD_CMD)))
#define 	CLCD_DATA_ADDR		(*((volatile unsigned char *)(FPGA_CLCD_DATA)))
#define 	FND_CS0     		(*((volatile unsigned char *)(FPGA_FND_CS0)))
#define		FND_CS1     		(*((volatile unsigned char *)(FPGA_FND_CS1)))
#define 	FND_CS2     		(*((volatile unsigned char *)(FPGA_FND_CS2)))
#define 	FND_CS3     		(*((volatile unsigned char *)(FPGA_FND_CS3)))
#define 	FND_CS4     		(*((volatile unsigned char *)(FPGA_FND_CS4)))
#define 	FND_CS5     		(*((volatile unsigned char *)(FPGA_FND_CS5)))
#define 	FND_CS6     		(*((volatile unsigned char *)(FPGA_FND_CS6)))
#define 	FND_CS7	     		(*((volatile unsigned char *)(FPGA_FND_CS7)))
#define		DOT_COL_1               (*((volatile unsigned char *)(FPGA_DOT_COL_1)))
#define 	DOT_COL_2               (*((volatile unsigned char *)(FPGA_DOT_COL_2)))
#define 	DOT_COL_3               (*((volatile unsigned char *)(FPGA_DOT_COL_3)))
#define 	DOT_COL_4               (*((volatile unsigned char *)(FPGA_DOT_COL_4)))
#define 	DOT_COL_5               (*((volatile unsigned char *)(FPGA_DOT_COL_5)))

#define 	FND_RESET		3
#define 	MAX_FND			8

static unsigned char disp[8] = {0};
static unsigned char dot_col[5]={0};
/***************************************************************
	LED  TEST
****************************************************************/
void led_test(){

	unsigned char data, data2;
        int  count;

	data = 0x00;
        for ( count = 0; count <16 ; count++){
                data2 = (~(data >> 7)) & 0x01;
                data  = (data << 1 ) | data2;
                LED_CS = data;
		mdelay(10);
                
        }

	for( count =0 ; count <15; count ++) {
                if( count%2){
                        data = 0xff;
               		LED_CS = data;
                }
                else{
                        data = 0x00;
               		LED_CS = data;
                }
                mdelay(10);
	}
}

/***************************************************************
	CLCD TEST
****************************************************************/
static void lcd_init(void){
	
	CLCD_CMD_ADDR = 0x38;
        mdelay(10);
        CLCD_CMD_ADDR = 0x38;
        mdelay(10);
        CLCD_CMD_ADDR = 0x38;
        mdelay(10);
        CLCD_CMD_ADDR = 0x0e;
        mdelay(10);
        CLCD_CMD_ADDR = 0x02;
        mdelay(10);
        CLCD_CMD_ADDR = 0x01;
        mdelay(10);

}

static void string_out(char *str)
{
        char *s;
        int i=0;

      //  printk("clcd.o: %s\n", str);

        lcd_init();

        for (s=str; *s; s++){
                CLCD_DATA_ADDR = *s;

                if(i == 15) {
                        udelay(100);
                        CLCD_CMD_ADDR = 0xC0;
                }

                udelay(100);
                i++;
        }
}

static void clcd_test(){

	string_out("www.hybus.net   Education Board");	

}

/***************************************************************
	FND TEST
****************************************************************/
static void fnd_clear(void){

/* GPCR(FND_RESET) |= GPIO_bit(FND_RESET);
 GPSR(FND_RESET) |= GPIO_bit(FND_RESET);

*/
    FND_CS0 = 0x00;
    FND_CS1 = 0x00;
    FND_CS2 = 0x00;
    FND_CS3 = 0x00;
    FND_CS4 = 0x00;
    FND_CS5 = 0x00;
    FND_CS6 = 0x00;
    FND_CS7 = 0x00;

}

static void fnd_write(void){
     int i;
	
     for(i =1; i <= MAX_FND; i++){
    	switch(i)
   	 {   
       		case  1:    FND_CS7 = disp[0];  break;
        	case  2:    FND_CS6 = disp[1];  break;
        	case  3:    FND_CS5 = disp[2];  break;
        	case  4:    FND_CS4 = disp[3];  break;
        	case  5:    FND_CS3 = disp[4];  break;
        	case  6:    FND_CS2 = disp[5];  break;
        	case  7:    FND_CS1 = disp[6];  break;
        	case  8:    FND_CS0 = disp[7];  break;
        	default :   break;
    	  }
     }
}
unsigned char asc_to_fnd(int n){
        unsigned char c;

                switch (n) {
                        /*  ڸ ߰Ҽ ִ */
                        case  0: c = 0x3f; break;
                        case  1: c = 0x06; break;
                        case  2: c = 0x5b; break;
                        case  3: c = 0x4f; break;
                        case  4: c = 0x66; break;
                        case  5: c = 0x6d; break;
                        case  6: c = 0x7d; break;
                        case  7: c = 0x07; break;
                        case  8: c = 0x7f; break;
                        case  9: c = 0x67; break;
                        default: c = 0x00; break;
                }
        return c;
}

static void fnd_test(void){
	int n, count;

 	fnd_clear();

	for (n = 0 ; n <= 9; n++)
        {
                for( count = 0 ; count < MAX_FND; count++){
                disp[count]= asc_to_fnd(n);
                }
		fnd_write();
                mdelay(100);
        }


		
}

/***************************************************************
	DOT TEST
****************************************************************/

static int dot_reset(void){

       /* GPCR(DOT_RESET) |= GPIO_bit(DOT_RESET);
        GPSR(DOT_RESET) |= GPIO_bit(DOT_RESET);
        */
	
	DOT_COL_1       = 0x00;
        DOT_COL_2       = 0x00;
        DOT_COL_3       = 0x00;
        DOT_COL_4       = 0x00;
        DOT_COL_5       = 0x00;
	return 0;
}

static unsigned char asc_to_dot(int asc){
                switch( asc){
                        case 0 :  dot_col[0] = 0x7F; dot_col[1] = 0x41; dot_col[2] = 0x41; dot_col[3] = 0x41; dot_col[4] = 0x7F; break;
                        case 1 :  dot_col[0] = 0x00; dot_col[1] = 0x00; dot_col[2] = 0x7F; dot_col[3] = 0x00; dot_col[4] = 0x00; break;
                        case 2 :  dot_col[0] = 0x4F; dot_col[1] = 0x49; dot_col[2] = 0x49; dot_col[3] = 0x49; dot_col[4] = 0x79; break;
                        case 3 :  dot_col[0] = 0x49; dot_col[1] = 0x49; dot_col[2] = 0x49; dot_col[3] = 0x49; dot_col[4] = 0x7F; break;
                        case 4 :  dot_col[0] = 0x78; dot_col[1] = 0x08; dot_col[2] = 0x7F; dot_col[3] = 0x08; dot_col[4] = 0x08; break;
                        case 5 :  dot_col[0] = 0x79; dot_col[1] = 0x49; dot_col[2] = 0x49; dot_col[3] = 0x49; dot_col[4] = 0x4F; break;
                        case 6 :  dot_col[0] = 0x7F; dot_col[1] = 0x49; dot_col[2] = 0x49; dot_col[3] = 0x49; dot_col[4] = 0x4F; break;
                        case 7 :  dot_col[0] = 0x40; dot_col[1] = 0x40; dot_col[2] = 0x40; dot_col[3] = 0x40; dot_col[4] = 0x7F; break;
                        case 8 :  dot_col[0] = 0x7F; dot_col[1] = 0x49; dot_col[2] = 0x49; dot_col[3] = 0x49; dot_col[4] = 0x7F; break;
                        case 9 :  dot_col[0] = 0x78; dot_col[1] = 0x48; dot_col[2] = 0x48; dot_col[3] = 0x48; dot_col[4] = 0x7F; break;
        }
}

static void dot_write(void){
 	int col_number;

	for ( col_number =0 ; col_number < 6 ; col_number++){
        	switch( col_number){
                        case 1 : DOT_COL_1 = dot_col[0]; break;
                        case 2 : DOT_COL_2 = dot_col[1]; break;
                        case 3 : DOT_COL_3 = dot_col[2]; break;
                        case 4 : DOT_COL_4 = dot_col[3]; break;
                        case 5 : DOT_COL_5 = dot_col[4]; break;
                }
        }

}

static void dot_test(){
	int count;

	dot_reset();
	for (count =0 ; count <= 9; count++) {
                asc_to_dot(count);
		dot_write();
                mdelay(50);
        }


}

/***************************************************************

****************************************************************/
void ieb_init(void){

	led_test();
	dot_test();
	fnd_test();
	clcd_test();
	
}
