#include <config.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <command.h>
#include <ieb.h>

extern void pxafb_disable(void);
extern bool eth_init(void);
extern bool uart_init(void);
extern bool config_init(void);
extern bool iflash_init(void);

int main(void){
	int count;
	bool autoboot=true;

	uart_init();
	uart_init();
	pxafb_disable();
	time_init();
	config_init();

	printf("\033[H\033[J\n");		// clear screen.
	printf(" %s : bootloader for xhyper board\n", PACKAGE);
	printf(" Copyright (C) 2002-2004 Hybus Co,. ltd.\n");
	printf(" support : http://www.hybus.net\n");

	iflash_init();
	eth_init();
	printf(" IEB board TEST\n");
	ieb_init(); 	//270_tku ieb init
	printf(" autoboot in progress, press any key to stop.");
		
	count = 2000;
	autoboot = true;
	do {
		if (getc() != -1){ autoboot=false; break; }
		if (!(--count % 1000)) putc('.');
		mdelay(1);
	} while (count);
	putc('\n');

	if (autoboot){
		printf(" autoboot started.\n");
		autoboot_mode();
	}	

	printf(" autoboot aborted\n");
	printf(" type \"help\" to get a list of commands\n");
	command_mode();
	while (1);
	return 0;
}
