


#include <config.h>
#include <setup.h>
#include <board.h>
#include <string.h>


static struct map __bsetup parts[] = {
	{
		.name   = "loader",
		.sramb  = LOADER_SRAM_BASE,
		.srams  = LOADER_MAX_SIZE,
		.dramb  = LOADER_DRAM_BASE,
		.maxs   = LOADER_MAX_SIZE,
	}, {
		.name   = "kernel",
		.sramb  = KERNEL_SRAM_BASE,
		.srams  = KERNEL_MAX_SIZE,
		.dramb  = KERNEL_DRAM_BASE,
		.maxs   = KERNEL_MAX_SIZE,
	}, {
		.name   = "ramdisk",
		.sramb  = RAMDISK_SRAM_BASE,
		.srams  = RAMDISK_MAX_SIZE,
		.dramb  = RAMDISK_DRAM_BASE,
		.maxs   = RAMDISK_MAX_SIZE,
	}, {
		.name   = "root",
		.sramb  = ROOTFS_SRAM_BASE,
		.srams  = ROOTFS_MAX_SIZE,
		.dramb  = ROOTFS_DRAM_BASE,
		.maxs   = ROOTFS_MAX_SIZE,
	}
};
static const int nparts = sizeof(parts) / sizeof(parts[0]);

void init_map(void){
	struct map *part;
	part = parts;
	while (part < parts + nparts){
		part->drams = 0;
		part++;
	}
	return;
}

struct map *find_map(const char *name){
	struct map *part;
	part = parts;
	while (part < parts + nparts){
		if (!strcmp(part->name, name))
			return part;
		part++;
	}
	return 0;
}
