

#include <config.h>
#include <hardware.h>


.section .text
.global _start
_start :
	bl		define_gpio
	bl		clock_enable
	bl		setup_memory		@ setup static and dynamic memory

	@ copy bootloader to dynamic memory area
	ldr		r0, =0x00
	ldr		r1, =__boot_start
	ldr		r2, =__boot_end
 1:	ldmia	r0!, {r3-r10}
	stmia	r1!, {r3-r10}
	cmp		r1, r2
	blt		1b

	@ clear bss area
	mov		r3, #0x00
	mov		r4, #0x00
	mov		r5, #0x00
	mov		r6, #0x00
	ldr		r0, =bss_start
	ldr		r1, =bss_end
 1:	stmia	r0!, {r3-r6}
	cmp		r0, r1
	blt		1b

	@ set stack point
	ldr		sp, =stack_point-4

	@ jump to c code
	ldr		pc, =main

clock_enable :
#if defined(CONFIG_PXA25x)
	ldr		r0, =0x0001FFFF
#elif defined(CONFIG_PXA27x)
	ldr		r0, =0x01FFFFFF
#endif
	ldr		r1, =CKEN
	str		r0, [r1]
	mov		pc, lr
