

#include <types.h>
#include <stdarg.h>
#include <serial.h>

extern int vsprintf(char *buff, const char *fmt, va_list args);

int printf(const char *fmt, ...){
	int n;
	char buff[1024];
	va_list args;

	va_start(args, fmt);
	n = vsprintf(buff, fmt, args);
	va_end(args);

	buff[n] = '\0';
	uart_puts(buff);
	return n;
}

int getc(void){
	return uart_getc();
}

int putc(int ch){
	return uart_putc(ch);
}

int putchar(int ch){
	return uart_putc(ch);
}

int puts(const char *s){
	const char *t = s;
	while (*t)
		uart_putc(*t++);
	uart_putc('\n');
	return t-s+1;
}
